//----------------------------------------------------------------------------
// 
//	file: disputil_window.cc
// 
//	function: pop up window for quick display of standard 
//		arrays and matrices 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Thu Sep 24 23:06:32 CDT 1998
// 
//	$Revision: 1.2 $ $Date: 1999/02/09 07:42:25 $
//	$Log: disputil_window.cc,v $
//	Revision 1.2  1999/02/09 07:42:25  yschoe
//	*** empty log message ***
//
//	Revision 1.1  1998/10/05 19:48:46  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------

#include "disputil_window.h"


//----------------------------------------------------------------------------
//	disputil_window() 
//	  - Constructor
//----------------------------------------------------------------------------
disputil_window::disputil_window(char *name, int w, int h, int x, int y ) 
	: tool_window(name, w, h, x, y, 0) {

  // do nothing
  //toggle();

}
//----------------------------------------------------------------------------
// directly call disp_matrix
disputil_window::disputil_window(char *name, REAL **mat, int cols, 
	int rows, int gran) : tool_window(name, cols*gran, rows*gran, 0, 0, 0){

  disp_width = cols*gran;
  disp_height = rows*gran;
  disp_matrix(mat, cols, rows);
  //toggle();

}

//----------------------------------------------------------------------------
//	~disputil_window() 
//	  - destructor
//----------------------------------------------------------------------------
disputil_window::~disputil_window() {

  // free windows that has been created.

  /*
  if (matw) {
	delete matw;
  }

  if (plotw) {
	delete plotw;
  }
  */

}

//----------------------------------------------------------------------------
//	disp_matrix() 
//	  - display 2D matrix
//----------------------------------------------------------------------------
void disputil_window::disp_matrix(REAL **mat, int cols, int rows) {
  
  matw = new matrix_window(*this, disp_width, disp_height, 0, 0, 0, 60, COLOR, 
		cols, rows, mat);
  matw->redraw();
  XFlush(display);

}

