//----------------------------------------------------------------------------
// 
//	file: slissom2-2.cc
// 
//	function: 2 interacting cortical layers 
//		  and a single retina 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Sat Dec 26 23:11:52 CST 1998
// 
//	$Revision: 1.21 $ $Date: 2003/01/12 18:03:12 $
//	$Log: slissom2-2.cc,v $
//	Revision 1.21  2003/01/12 18:03:12  yschoe
//	*** empty log message ***
//
//	Revision 1.20  2003/01/12 18:02:18  yschoe
//	made curvature input routine to work.
//
//	Revision 1.19  2001/06/20 16:58:47  yschoe
//	removed obsolete code blocks
//
//	Revision 1.18  2001/06/20 16:57:41  yschoe
//	added input distribution control flags: invert_xy_flag, rotate_or_flag
//
//	Revision 1.17  2000/02/27 10:52:07  yschoe
//	added
//	1. dump wgt or histo / weighted and non-weighted
//
//	Revision 1.16  2000/02/22 03:56:41  yschoe
//	1. save C.O.G. routine added
//	2. fixed so that it runs well in text mode (tslissom2-2)
//
//	Revision 1.15  2000/02/13 10:30:21  yschoe
//	use hash.
//	option to load or_map from ascii dump for display.
//
//	Revision 1.14  2000/02/13 05:50:27  yschoe
//	*** empty log message ***
//
//	Revision 1.13  2000/02/08 11:25:38  yschoe
//	*** empty log message ***
//
//	Revision 1.12  2000/01/30 14:55:55  yschoe
//	*** empty log message ***
//
//	Revision 1.11  1999/03/30 12:46:28  yschoe
//	1. spikelayer3 class can be used instead (optional)
//	2. orientation map display in GUI window
//	3. neuron stat plot while trainig/testing
//	4. hsv_spike_flag , uniform_wgt_flag, input_delay added
//	5. LAMBDA_SYN and LAMBDA_INH overridden by synapse_decay and inhloop_decay
//	6. call_resize_lat_inh_rad added
//	7. uniform_wgt_flag
//
//	8. weight display made more versatile
//
//	Revision 1.10  1999/03/05 11:04:23  yschoe
//	added synapse_decay and inhloop_decay to config file
//
//	Revision 1.9  1999/02/25 09:17:01  yschoe
//	added on-line muaplot capability
//
//	Revision 1.8  1999/02/09 07:56:44  yschoe
//	added call_kill_lat_weights() commands to parser interface
//
//	Revision 1.7  1999/02/08 08:04:40  yschoe
//	*** empty log message ***
//
//	Revision 1.6  1999/02/06 05:09:13  yschoe
//	added input spec list stuff.
//
//	Revision 1.5  1999/02/04 22:11:30  yschoe
//	removed COG calculation and made it refer to the same routine in netlayer
//	class.
//
//	Revision 1.4  1999/01/10 04:15:02  yschoe
//	1. added CF_RAD and CF_RAD2 for inter area RF size
//	2. separator between or map output changed to series of numbers for
//	easier plotting later.
//
//	Revision 1.3  1999/01/07 09:48:26  yschoe
//	save both maps at the end of training
//
//	Revision 1.2  1999/01/07 09:39:49  yschoe
//	1. added or pref calculation
//	2. command line loading of both map images
//
//	Revision 1.1  1998/12/31 08:03:30  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: slissom2.cc
// 
//	function: modify slissom algorithm to be more robust to parameters 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Mon Nov 30 22:45:30 CST 1998
// 
//	$Revision: 1.21 $ $Date: 2003/01/12 18:03:12 $
//	$Log: slissom2-2.cc,v $
//	Revision 1.21  2003/01/12 18:03:12  yschoe
//	*** empty log message ***
//
//	Revision 1.20  2003/01/12 18:02:18  yschoe
//	made curvature input routine to work.
//
//	Revision 1.19  2001/06/20 16:58:47  yschoe
//	removed obsolete code blocks
//
//	Revision 1.18  2001/06/20 16:57:41  yschoe
//	added input distribution control flags: invert_xy_flag, rotate_or_flag
//
//	Revision 1.17  2000/02/27 10:52:07  yschoe
//	added
//	1. dump wgt or histo / weighted and non-weighted
//
//	Revision 1.16  2000/02/22 03:56:41  yschoe
//	1. save C.O.G. routine added
//	2. fixed so that it runs well in text mode (tslissom2-2)
//
//	Revision 1.15  2000/02/13 10:30:21  yschoe
//	use hash.
//	option to load or_map from ascii dump for display.
//
//	Revision 1.14  2000/02/13 05:50:27  yschoe
//	*** empty log message ***
//
//	Revision 1.13  2000/02/08 11:25:38  yschoe
//	*** empty log message ***
//
//	Revision 1.12  2000/01/30 14:55:55  yschoe
//	*** empty log message ***
//
//	Revision 1.11  1999/03/30 12:46:28  yschoe
//	1. spikelayer3 class can be used instead (optional)
//	2. orientation map display in GUI window
//	3. neuron stat plot while trainig/testing
//	4. hsv_spike_flag , uniform_wgt_flag, input_delay added
//	5. LAMBDA_SYN and LAMBDA_INH overridden by synapse_decay and inhloop_decay
//	6. call_resize_lat_inh_rad added
//	7. uniform_wgt_flag
//
//
//
//
//	8. weight display made more versatile
//
//	Revision 1.10  1999/03/05 11:04:23  yschoe
//	added synapse_decay and inhloop_decay to config file
//
//	Revision 1.9  1999/02/25 09:17:01  yschoe
//	added on-line muaplot capability
//
//	Revision 1.8  1999/02/09 07:56:44  yschoe
//	added call_kill_lat_weights() commands to parser interface
//
//	Revision 1.7  1999/02/08 08:04:40  yschoe
//	*** empty log message ***
//
//	Revision 1.6  1999/02/06 05:09:13  yschoe
//	added input spec list stuff.
//
//	Revision 1.5  1999/02/04 22:11:30  yschoe
//	removed COG calculation and made it refer to the same routine in netlayer
//	class.
//
//	Revision 1.4  1999/01/10 04:15:02  yschoe
//	1. added CF_RAD and CF_RAD2 for inter area RF size
//	2. separator between or map output changed to series of numbers for
//	easier plotting later.
//
//	Revision 1.3  1999/01/07 09:48:26  yschoe
//	save both maps at the end of training
//
//	Revision 1.2  1999/01/07 09:39:49  yschoe
//	1. added or pref calculation
//	2. command line loading of both map images
//
//	Revision 1.1  1998/12/31 08:03:30  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: slissom.cc
// 
//	function: test spikelayer2_2 class 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Sun Sep 27 05:49:27 CDT 1998
// 
//	Revision: 1.6  Date: 1998/11/09 13:23:42 
//	Log: slissom.cc,v 
//	Revision 1.6  1998/11/09 13:23:42  yschoe
//	*** empty log message ***
//
//	Revision 1.5  1998/10/26 04:02:22  yschoe
//	1. weight display windows added
//	2. network weight setup parameters added to blackboard for easier
//	   customization with the conf file
//	3. filename handling got better by the use of filename class.
//	4. simulation environment and network image separated.
//	5. command hooks used with the simulation environment.
//
//	Revision 1.4  1998/10/18 06:14:58  yschoe
//	*** empty log message ***
//
//	Revision 1.3  1998/10/16 10:35:21  yschoe
//	added randomness, and added a couple of display windows.
//
//	Revision 1.2  1998/10/05 19:59:23  yschoe
//	now capable of  gaussian initial weights.
//
//	Revision 1.1  1998/10/02 09:24:16  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: lissom.cc
// 
//	function: defines and implements LISSOM 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Wed Aug  5 18:04:55 CDT 1998
// 
//	Revision: 1.15 Date: 1998/09/14 06:03:04 
//	Log: lissom.cc,v -- see rlog
//
//----------------------------------------------------------------------------
#define lissom_version "slissom2-2.cc $Revision: 1.21 $"

#define VERSION2_2

#ifdef VERSION3
#undef VERSION3
#endif

#ifdef LissomTcl
#define LissomCUI
#endif

#include <iostream.h>
#include <stdlib.h>
#include <signal.h>
#ifdef VERSION3
#include <nnview/spikelayer3.h>
#elif defined(VERSION2_2)
#include <nnview/spikelayer2-2.h>
#else
#include <nnview/spikelayer2.h>
#endif
#include <nnview/simulog.h>
#include <nnview/real.h>
#include <nnview/coord.h>
#include <nnview/geninput.h>
#include <nnview/simenv.h>
#include <nnview/filename.h>
#include <nnview/inputlist.h>
#include <nnview/matrix.h>
#include <nnview/simstat.h>
#include <nnview/ppmio.h>

// for readline
extern "C" {
#include <readline/readline.h>
#include <readline/history.h>
}

#ifndef LissomCUI
#include <window.h>
#include <nnview/plot_window.h>
#include <nnview/matrix_window.h>
#include <nnview/tool_window.h>
#include <nnview/net_window.h>
#include <nnview/disputil_window.h>
#include <nnview/gdb_visualize.h>
#include <nnview/affw_window.h>
#include <nnview/latw_window.h>
#endif

#ifdef VERSION2_2
// #define spikelayer2 spikelayer2_2
#endif

//----------------------------------------------------------------------------
// Network topology and simulation parameters
simenv	*environment;
simstat *stats;
simstat *stats2;
int 	N = 11;		// map1 
int 	M = 11;
int 	INH_RAD = 11;
int 	EXC_RAD = 7;
int 	RF_RAD = 9;
int 	CF_RAD = 1;

int	N2 = 1;		// map2 : make it minimal by default
int	M2 = 1;
int	INH_RAD2 = 1;
int	EXC_RAD2 = 1;
int	RF_RAD2 = 1;
int 	CF_RAD2 = 1;

int 	GRAN = 5;
int 	WGT_GRAN = 2;
REAL 	LAMBDA_SYN = 0.3;
REAL 	LAMBDA_INH = 0.1;
REAL 	randomness=1.0;
REAL 	aff_setup_decay=-1.0;
REAL 	lat_inh_setup_decay=1.0;
REAL 	lat_exc_setup_decay=3.0;
REAL 	sigmax=0.01;
REAL 	sigmay=0.01;
REAL 	wgt_disp_scale=1.0;
int 	disp_rate = 1;
int 	wgt_disp_rate = 1000;
int 	iters = 0;
int 	iters_per_run = 10;
int 	tsettle = 9;
int 	test_flag = 0;
char 	conffilename[100]; // config file base name
char 	buffname[100]; // config file base name
int     save_rate = 5000;
int     wgt_disp_flag = 0;
int	instar_norm = 0;
REAL	scaleup=1.0;
int	hsv_spike_flag=0;
int	uniform_wgt_flag=0;
int	cur_x, cur_y; // training input location
int 	cur_t;
int	disp_spike_flag=0;
int	disp_spike2_flag=0;
int	padded_flag=1;	// 00Nov5 : padded retina -- on by default (==1)
int	dump_demo_flag=0;
int	dump_demo_map1_flag=0;
int	clear_upper_hemisphere_flag = 0;
REAL	clear_upper_hemisphere_prob = 0.5;
int	illusory_input_flag = 0;
int	invert_xy_flag = 0;
int	swap_xy_flag = 0;
int	rotate_or_flag = 0;
int	circular_intra_columnar_rf_flag = 0;
int	clear_input_rows_begin = -1;
int	clear_input_rows_end = -1;

int	hemifield_curvature_flag = 0;
REAL	upper_hemifield_curvature = 1.0;
REAL	lower_hemifield_curvature = 1.0; 

// these negative values are just used to check if the 
// parameters are set from the conf file. They must be
// explicitly declared in the conf file since these
// values are in a meaningliess range.
REAL	synapse_decay = -9.9;
REAL	inhloop_decay = -9.9;
REAL	synapse_decay2 = -9.9;
REAL	inhloop_decay2 = -9.9;

int	mua_map_select = 2; // select which map's mua to display: default is
			    // map2! 03Apr09

int	ansi_disp_flag = 0;

int	input_delay = 1;

int	delayed_normalization_flag = 1;

int     steps;
int 	t=0;
simulog	*netlog;

// maps (layers)
netlayer	*input;
spikelayer2_2	*map;
spikelayer2_2	*map2;

coord		**ideal;
coord		**ideal2;

geninput	*input_generator; // input generator class
inputlist	*input_spec_list; 	  // list of input specs

matrix<REAL>	*map1_or;
matrix<REAL>	*map2_or;
matrix<REAL>	*map1_or_selectivity;
matrix<REAL>	*map2_or_selectivity;

// End : network topology and simulation environment stuff
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// prototypes
void tcl_run();
void affdisp();
int  call_clear_spec(int argc, char *argv[]);
int  call_add_spec_rect(int argc, char *argv[]);
int  call_add_spec_ori_gaus(int argc, char *argv[]);
void save();
int  call_save(int argc, char *argv[]);
int  dump_affw(int argc, char *argv[]);
int  dump_excw(int argc, char *argv[]);
int  dump_inhw(int argc, char *argv[]);
void dump_selectw(int select);

//----------------------------------------------------------------------------
// GUI stuff
#ifndef LissomCUI

class mymain_window : public main_window {

public:
  mymain_window(char *name, int x, int y) : main_window(name,x,y) {
     selection_mask |= ButtonPressMask | ButtonReleaseMask | PointerMotionMask;
     polling_mode = False; // change this to True if real interactivity needed
  }
  ~mymain_window(){};
  void polling_handler() {
	iters_per_run=1;
	tcl_run();
  }	
	
};

mymain_window     *mw;

plot_window     *pw ;
plot_window     *pw2 ;
plot_window     *pw3 ;

plot_window 	*pwinlist[20];

matrix_window   *matw; 
matrix_window   *matw2;
matrix_window   *inpw;
matrix_window   *spikew;
matrix_window   *spikew2;
matrix_window   *avgw;
matrix_window   *avgw2;
matrix_window   *orw;
matrix_window   *orw2;
matrix_window   *netaffw;
matrix_window   *netaffw2;
matrix_window   *netexcw;
matrix_window   *netexcw2;
matrix_window   *netinhw;
matrix_window   *netinhw2;

tool_window     *tw;

affw_window     *affdispw;
latw_window     *latinhdispw;
latw_window     *latexcdispw;
latw_window     *latcombdispw;

net_window	*nw;
net_window	*nw2;

callback_button *statit;
callback_button *runit;
callback_button *testit;
callback_button *saveit;
callback_button *affdispit;
callback_button *commandit;

#endif
// Matrices for displaying
REAL		**spikeact;
REAL		**spikeact2;

ppmio		*ppm_spikeact;
ppmio		*ppm_spikeact2;

// End: GUI stuff
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
//	chop() 
//	  - chop last entry in a string
//----------------------------------------------------------------------------
void chop(char *str) {

  str[strlen(str)-1] = '\0';

}

//----------------------------------------------------------------------------
//	repeat_print() 
//	  - print given string repetedly for given number of times
//----------------------------------------------------------------------------
void repeat_print(const char *str, int num) {

   for (int i=0; i<num; ++i) 
	cout << str;

   cout << endl;
}

//----------------------------------------------------------------------------
//	disp_spikes() 
//	  - display spikes
//----------------------------------------------------------------------------
void disp_spikes(int hsv_spike_flag, int test_flag) {

  static int count;
  static int pwin_flag=0;
  static int ori_flag=0;

#ifndef LissomCUI
  // allocate muaplot windows 
  if (pwin_flag==0 && test_flag) {

	int w = 1000;
 	int h = 100;
	tw = new tool_window("Tool",
		w,(h+5)*(stats->get_num_specs()),0,0);
	tw->toggle();

	for (int i=0; i<stats->get_num_specs(); ++i) {
  		pwinlist[i] = new plot_window(*tw,w,h,0,((h+5)*i),0,10,COLOR,
        			300,300);
	}

	pwin_flag = 1;
  }

  // calulate orientation map for further use
  if (ori_flag==0 && hsv_spike_flag == 1) {
     /* do not calculate it. Load it
     map->calc_or_pref(0,sigmax/2.0,sigmay/2.0);
     map2->calc_or_pref(0,sigmax/2.0,sigmay/2.0);
     */
     ori_flag = 1;
  }
#endif

  if (test_flag && disp_spike_flag) {
    cout << "spikes: " ;
    for (int i=0; i<map->cols; ++i)
       for (int j=0; j<map->rows; ++j)  {
          spikeact[i][j] = (REAL)(map->spikeact_q[i][j]&0x1);
          cout << ((int)spikeact[i][j]) << " ";
       }
    cout << endl;
  }

  if (test_flag && disp_spike2_flag) {
    cout << "spikes2: " ;
    for (int i=0; i<map2->cols; ++i)
       for (int j=0; j<map2->rows; ++j)  {
          spikeact2[i][j] = (REAL)(map2->spikeact_q[i][j]&0x1);
          cout << ((int)spikeact2[i][j]) << " ";
       }
    cout << endl;
  }

  // get spike values
  if (hsv_spike_flag==1) {
	  for (int i=0; i<map->cols; ++i) 
	     for (int j=0; j<map->rows; ++j)
		spikeact[i][j] = (REAL)(map->spikeact_q[i][j]&0x1)*map->or_pref[i][j];
	  for (int i=0; i<map2->cols; ++i) 
	     for (int j=0; j<map2->rows; ++j)
		spikeact2[i][j] = (REAL)(map2->spikeact_q[i][j]&0x1)*map2->or_pref[i][j];
  } else {
  for (int i=0; i<map->cols; ++i) 
     for (int j=0; j<map->rows; ++j)
	spikeact[i][j] = (REAL)(map->spikeact_q[i][j]&0x1);
  for (int i=0; i<map2->cols; ++i) 
     for (int j=0; j<map2->rows; ++j)
	spikeact2[i][j] = (REAL)(map2->spikeact_q[i][j]&0x1);
  }


  if (test_flag && count>1) {
    cout << "mua " << count << " " ;
    for (int i=0; i<stats->get_num_specs(); ++i) {
	cout << stats->sum_area(i) << " ";

#ifndef LissomCUI

	// Display MUA areas in the map layer windows
	// to verify if the provided MUA specs are correct.
	switch ((int)stats->get_type(i)) {
	case (int)SS_CIRCLE :  // circle spec
		matw->draw_circle(stats->get_cx(i),stats->get_cy(i),
			stats->get_cradius(i),1.0);
		spikew->draw_circle(stats->get_cx(i),stats->get_cy(i),
			stats->get_cradius(i),1.0);
		matw2->draw_circle(stats2->get_cx(i),stats2->get_cy(i),
			stats2->get_cradius(i),1.0);
		spikew2->draw_circle(stats2->get_cx(i),stats2->get_cy(i),
			stats2->get_cradius(i),1.0);
		break;
	case (int)SS_SQR:  	 // square spec
		matw->draw_square(stats->get_cx(i),stats->get_cy(i),
			stats->get_radius(i));
		spikew->draw_square(stats->get_cx(i),stats->get_cy(i),
			stats->get_radius(i));
		// spikew2->draw_square(stats2->get_cx(i),stats2->get_cy(i),
		//	stats2->get_radius(i));	
		break;
	case (int)SS_BBOX:    // bounding box (rectangle) spec
		matw->draw_rectangle( stats->get_lowx(i), stats->get_lowy(i),
			stats->get_highx(i), stats->get_highy(i));
		spikew->draw_rectangle( stats->get_lowx(i), stats->get_lowy(i),
			stats->get_highx(i), stats->get_highy(i));
		// spikew2->draw_rectangle( stats2->get_lowx(i), 
		// stats2->get_lowy(i),
		//	stats2->get_highx(i), stats2->get_highy(i));
		break;
	default:
		cerr << "no such spec" << endl;	
	}
    	XFlush(display);  

	if (mua_map_select==1) {
		pwinlist[i]->push_data(stats->sum_area(i));
	} else {
		pwinlist[i]->push_data(stats2->sum_area(i));
	}
#endif
    }
#ifndef LissomCUI
    XFlush(display);  
#endif
    cout << endl;

    cout << "mua2 " << count << " ";
    for (int i=0; i<stats2->get_num_specs(); ++i) {
	cout << stats2->sum_area(i) << " ";
    }
    cout << endl;

    /*
    cout << "neuron_stat1 " << count << " "; map->print_stat(0,2,2);
    cout << "neuron_stat4 " << count << " "; map->print_stat(0,8,8);
    */
    /*
    cout << "neuron_stat1 " << count << " "; map->print_stat(0,2,3);
    cout << "neuron_stat2 " << count << " "; map->print_stat(0,2,8);
    cout << "neuron_stat3 " << count << " "; map->print_stat(0,8,3);
    cout << "neuron_stat4 " << count << " "; map->print_stat(0,8,8);
    */
    /* 
    cout << "neuron_stat1 " << count << " "; map->print_stat(0,5,2);
    cout << "neuron_stat2 " << count << " "; map->print_stat(0,5,5);
    cout << "neuron_stat3 " << count << " "; map->print_stat(0,5,8); 
    */
    for (int i=0; i<stats->get_num_specs(); ++i) {
      cout << "neuron_stat1-" << i << " " << count << " "; 
      map->print_stat(stats->get_cx(i),stats->get_cy(i));
    }

    for (int i=0; i<stats2->get_num_specs(); ++i) {
      cout << "neuron_stat2-" << i << " " << count << " "; 
      map2->print_stat(stats2->get_cx(i),stats2->get_cy(i));
    }
    count++;
	
  } else {

     if (count%disp_rate==0) { 
       cout << "neuron_stat1-" << 0 << " " << count << " "; 
       map->print_stat(0,cur_x,cur_y);
       cout << "neuron_stat2-" << 0 << " " << count << " "; 
       map2->print_stat(0,cur_x,cur_y);
     }

     count++;

  }

#ifdef LissomCUI
  if (ansi_disp_flag==1) {
	  if (hsv_spike_flag==1) {
		ppm_spikeact->ppmansi(stdout,0.0,0.0,PPM_HSV2);
		ppm_spikeact2->ppmansi(stdout,0.0,0.0,PPM_HSV2);
	  } else {
		ppm_spikeact->ppmansi();
		ppm_spikeact2->ppmansi();
	  }
  }
#endif 

#ifndef LissomCUI
  spikew->redraw();
  spikew2->redraw();
  netaffw->redraw();
  netaffw2->redraw();
  XFlush(display);  
#endif

}

//----------------------------------------------------------------------------
//	save_or_pref() 
//	  - save or preference of map1 afferents
//----------------------------------------------------------------------------
int save_or_pref(int argc, char *argv[]) {

  char	or_fname[256];

  spikelayer2_2 *map_p;
  matrix<REAL>	*or_p;

  int map_num = atoi(argv[1]);

  if (map_num==1) {
	map_p = map;
	or_p  = map1_or;
  } else if (map_num==2)  {
	map_p = map2;
	or_p  = map2_or;
  } else {
	cerr << "save_or_pref : invalid map number" << endl;
	return 0;
  }	

  cerr << "save_or_pref : saving map " << map_num << endl;

  // save preference
  map_p->calc_or_pref(0,sigmax/2.0,sigmay/2.0);
  or_p->import_matrix(map_p->or_pref);
  sprintf(or_fname,
       "%s%06d.map%d-0.or",
       filename::swap_ext(buffname,conffilename,""),
       cur_t,
       map_num);
  map_p->save_or_pref(0,or_fname);

  // save selectivity
  or_p->import_matrix(map_p->or_selectivity);
  sprintf(or_fname,
       "%s%06d.map%d-0.orselec",
       filename::swap_ext(buffname,conffilename,""),
       cur_t,
       map_num);
  map_p->save_or_selectivity(0,or_fname);
  return 1;

}
//----------------------------------------------------------------------------
int save_or_prefs(int argc, char *argv[]) {

   char *arg1[2] = { "" , "1" };
   char *arg2[2] = { "" , "2" };

   save_or_pref(1,arg1);
   save_or_pref(1,arg2);

   return 1;

}
//----------------------------------------------------------------------------
//	save_cog() 
//	  - save cog 
//----------------------------------------------------------------------------
int save_cog(int argc, char *argv[]) {

  char	cog_fname[256];

  cerr << "save_cog(): saving map1 COG\n";
  sprintf(cog_fname,
       "%s%06d.map1-0.cog",
       filename::swap_ext(buffname,conffilename,""),
       cur_t);
  cerr << "	fname = " << cog_fname << endl;
  map->save_cog(0,cog_fname);

  cerr << "save_cog(): saving map2 COG\n";
  sprintf(cog_fname,
       "%s%06d.map2-0.cog",
       filename::swap_ext(buffname,conffilename,""),
       cur_t);
  cerr << "	fname = " << cog_fname << endl;
  map2->save_cog(0,cog_fname);
  return 1;

}

//----------------------------------------------------------------------------
//	call_set_additive() 
//	  - set additive flag in input_generator
//----------------------------------------------------------------------------
int  call_set_additive(int argc, char *argv[]) {

    	input_generator->set_additive();
	return 1;

}

//----------------------------------------------------------------------------
//	call_reset_additive() 
//	  - reset additive flag in input_generator
//----------------------------------------------------------------------------
int  call_reset_additive(int argc, char *argv[]) {

    	input_generator->reset_additive();
	return 1;

}

//----------------------------------------------------------------------------
//	call_clear_spec() 
//	  - clear input spec
//----------------------------------------------------------------------------
int  call_clear_spec(int argc, char *argv[]) {

	input_spec_list->call_clear(argc, argv);
	return 1;

}

//----------------------------------------------------------------------------
//	call_clear_mua_spec() 
//	  - clear mua spec
//----------------------------------------------------------------------------
int  call_clear_mua_spec(int argc, char *argv[]) {

  delete stats;
  delete stats2;

  stats       = new simstat(spikeact, N, N,20);
  stats2       = new simstat(spikeact2, N2, N2,20);
  
  return 1;
}

//----------------------------------------------------------------------------
//	call_add_spec_rect() 
//	  - add rectangular input to spec list
//----------------------------------------------------------------------------
int call_add_spec_rect(int argc, char *argv[]) {

	input_spec_list->call_add_spec_rect(argc, argv);
	return 1;

}

//----------------------------------------------------------------------------
//	call_add_spec_ori_gaus() 
//	  - add oriented gaussian input to spec list
//----------------------------------------------------------------------------
int call_add_spec_ori_gaus(int argc, char *argv[]) {

	input_spec_list->call_add_spec_ori_gaus(argc, argv);
	return 1;

}

//----------------------------------------------------------------------------
//	call_add_mua_spec_circle() 
//	  - add mua spec -- circular area
//----------------------------------------------------------------------------
int call_add_mua_spec_circle(int argc, char *argv[]) {

	stats->call_add_spec_circle(argc, argv);
	if (N==N2) {
		// for backward compatibility.
		// add stats2 spec only if map1 size == map2 size
	 	stats2->call_add_spec_circle(argc, argv);
	}
	return 1;

}

//----------------------------------------------------------------------------
//	call_add_mua_spec_circle() 
//	  - add mua spec -- circular area
//----------------------------------------------------------------------------
int call_add_mua_spec_circle2(int argc, char *argv[]) {

	if (N!=N2) {
		// for backward compatibility.
		// add stats2 spec only if map1 size != map2 size.
		// if map1 size == map2 size, call_add_mua_spec_circle()
		// sets up the spec identically to map1
		stats2->call_add_spec_circle(argc, argv);
	}
	return 1;

}

//----------------------------------------------------------------------------
//	call_add_mua_spec_sqr() 
//	  - add mua spec -- square area
//----------------------------------------------------------------------------
int call_add_mua_spec_sqr(int argc, char *argv[]) {

	stats->call_add_spec_sqr(argc, argv);
	if (N==N2) {
		// for backward compatibility.
		// add stats2 spec only if map1 size == map2 size
	 	stats2->call_add_spec_sqr(argc, argv);
	}
	return 1;

}

//----------------------------------------------------------------------------
//	call_add_mua_spec_bbox() 
//	  - add mua spec -- bounded box area
//----------------------------------------------------------------------------
int call_add_mua_spec_bbox(int argc, char *argv[]) {

	stats->call_add_spec_bbox(argc, argv);
	if (N==N2) {
		// for backward compatibility.
		// add stats2 spec only if map1 size == map2 size
	 	stats2->call_add_spec_bbox(argc, argv);
	}
	return 1;

}

//----------------------------------------------------------------------------
//      setup() 
//        - setup network for simulation
//----------------------------------------------------------------------------
void setup(char *cmdstr, char *configfile) {


  // copy config filename to conffilename
  strncpy(conffilename,configfile,strlen(configfile)+1);
  netlog = new simulog(cmdstr,filename::swap_ext(buffname,conffilename,"log"));

  netlog->append("command is %s ...",cmdstr);
  netlog->append("code version: %s",lissom_version);
  netlog->append("code version: %s",netlayer_version);

  //
  // 1. Setup simulation environment
  //
  environment = new simenv("slissom environment",100);

  // 1.1 add local simulation parameters to the 
  // 	 blackboard 
  environment->add("N",&N);
  environment->add("M",&M);
  environment->add("INH_RAD", &INH_RAD);
  environment->add("EXC_RAD", &EXC_RAD);
  environment->add("RF_RAD", &RF_RAD);
  environment->add("LAMBDA_SYN", &LAMBDA_SYN);
  environment->add("LAMBDA_INH", &LAMBDA_INH);
  environment->add("GRAN",&GRAN);
  environment->add("WGT_GRAN",&WGT_GRAN);
  environment->add("randomness",&randomness);
  environment->add("aff_setup_decay",&aff_setup_decay);
  environment->add("lat_exc_setup_decay",&lat_exc_setup_decay);
  environment->add("lat_inh_setup_decay",&lat_inh_setup_decay);
  environment->add("wgt_disp_scale",&wgt_disp_scale);
  environment->add("sigmax",&sigmax);
  environment->add("sigmay",&sigmay);
  environment->add("iters",&iters);
  environment->add("disp_rate",&disp_rate);
  environment->add("wgt_disp_rate",&wgt_disp_rate);
  environment->add("iters_per_run",&iters_per_run);
  environment->add("tsettle",&tsettle);
  environment->add("save_rate",&save_rate);
  environment->add("wgt_disp_flag",&wgt_disp_flag);
  environment->add("instar_norm",&instar_norm);
  environment->add("N2",&N2);
  environment->add("M2",&M2);
  environment->add("INH_RAD2", &INH_RAD2);
  environment->add("EXC_RAD2", &EXC_RAD2);
  environment->add("RF_RAD2", &RF_RAD2);
  environment->add("CF_RAD", &CF_RAD);
  environment->add("CF_RAD2", &CF_RAD2);
  environment->add("scaleup", &scaleup);
  environment->add("synapse_decay", &synapse_decay);
  environment->add("inhloop_decay", &inhloop_decay);
  environment->add("synapse_decay2", &synapse_decay2);
  environment->add("inhloop_decay2", &inhloop_decay2);
  environment->add("hsv_spike_flag", &hsv_spike_flag);
  environment->add("uniform_wgt_flag", &uniform_wgt_flag);
  environment->add("input_delay", &input_delay);
  environment->add("delayed_normalization_flag", &delayed_normalization_flag);
  environment->add("disp_spike_flag", &disp_spike_flag);
  environment->add("ansi_disp_flag", &ansi_disp_flag);
  environment->add("padded_flag", &padded_flag);
  environment->add("disp_spike2_flag", &disp_spike2_flag);
  environment->add("dump_demo_flag", &dump_demo_flag);
  environment->add("dump_demo_map1_flag", &dump_demo_map1_flag);
  environment->add("clear_upper_hemisphere_flag", &clear_upper_hemisphere_flag);
  environment->add("clear_upper_hemisphere_prob", &clear_upper_hemisphere_prob);
  environment->add("illusory_input_flag", &illusory_input_flag);
  environment->add("invert_xy_flag", &invert_xy_flag);
  environment->add("swap_xy_flag", &swap_xy_flag);
  environment->add("rotate_or_flag", &swap_xy_flag);
  environment->add("circular_intra_columnar_rf_flag", &circular_intra_columnar_rf_flag);
  environment->add("hemifield_curvature_flag", &hemifield_curvature_flag);
  environment->add("upper_hemifield_curvature", &upper_hemifield_curvature);
  environment->add("lower_hemifield_curvature", &lower_hemifield_curvature);
  environment->add("mua_map_select", &mua_map_select);

  environment->add("clear_input_rows_begin", &clear_input_rows_begin);
  environment->add("clear_input_rows_end", &clear_input_rows_end);

  // 1.2 read from file and set up hook tables
  // 	 input layer
  int count = environment->parse_file(configfile);

  // 1.3 log the dimension and stuff
  netlog->append("N = %d (map NxN)",N);
  netlog->append("M = %d (input MxM)",M);
  netlog->append("randomness = %f",randomness);

  //
  // 2. Set up map layers, and register maps in the environment, then
  //	run hooks
  //
  
  // 2.1 Input layer
  cout << "Initializing input layer.\n";
  input = new netlayer("input",M,M,0,0,0);
  
  // 2.2 SLISSOM layers
  cout << "Initializing map layer.\n";

  /* 00sep24 : these are replaced by lambda_*
  if (synapse_decay < 0.0 || inhloop_decay < 0.0) {
	cerr << " *** synapse_decay and inhloop_decay should be used "
		<< "instead of LAMBDA_SYN and LAMBDA_INH : exiting " << endl;
	exit(1);
  }
  */

  cerr << "*** padded_flag = " << padded_flag << endl;
	
  LAMBDA_SYN = synapse_decay;
  LAMBDA_INH = inhloop_decay;
  cerr << "slissom2-2: setup() - creating map1" << endl;
  map   = new spikelayer2_2("map",N,N,EXC_RAD,INH_RAD,2,input,M,M,RF_RAD,
	LAMBDA_SYN,LAMBDA_INH,0.0,0.0,padded_flag);
 
  /* 00sep24 : these are replaced by lambda_*
  if (synapse_decay2 < 0.0 || inhloop_decay2 < 0.0) {
	cerr << " *** synapse_decay and inhloop_decay should be used "
		<< "instead of LAMBDA_SYN and LAMBDA_INH : exiting " << endl;
	exit(1);
  }
  */
	
  LAMBDA_SYN = synapse_decay2;
  LAMBDA_INH = inhloop_decay2;
  cerr << "slissom2-2: setup() - creating map2" << endl;
  map2  = new spikelayer2_2("map2",N2,N2,EXC_RAD2,INH_RAD2,2,input,
	M2,M2,RF_RAD2,LAMBDA_SYN,LAMBDA_INH,0.0,0.0,padded_flag);
  cerr << "slissom2-2: setup() - map creation complete" << endl;

  // 2.2.1 link up map and map2 with very specific intercortial excitatory 
  // links
  map->add_inp_layer(map2,N2,N2,CF_RAD);
  map2->add_inp_layer(map,N,N,CF_RAD2);

  // 2.2.2 check if correct type of normalization is used.
  if (map->is_norm_by_sum()) {
      cout    	<< "***************** Warning ***************************\n"
      		<< "slissom : wrong normalization used in netlayer class.\n"
              	<< "    recompile the libnnview library and slissom.\n" 
          	<< "*****************************************************\n"
		<< endl;
  } 
  cout << "Normalization : " << 2.0 << " " << map->calc_norm_sum(2.0) << endl;

  // 2.3 add the spike layers to the environment, and add commands

  // map1
  environment->add_obj("lissom",map,"slissom layer");
  environment->add_alias("slissom","lissom");

  environment->add_cmd("lissom->call_resize_lat_exc_rad","lissom",
	&spikelayer2_2::call_resize_lat_exc_rad, 1, 
	" <I:radius>");
  environment->add_cmd("lissom->call_update_sig","lissom",
        &spikelayer2_2::call_update_sig, 2,
        " <R:sig_low> <R:sig_high>");
  environment->add_cmd("lissom->call_dump_wgts_range","lissom",
        &spikelayer2_2::call_dump_wgts_range, 4,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row>");
  environment->add_cmd("lissom->call_dump_wgt_sums_range","lissom",
        &spikelayer2_2::call_dump_wgt_sums_range, 4,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row>");
  environment->add_cmd("lissom->call_kill_lat_weights","lissom",
        &spikelayer2_2::call_kill_lat_weights, 1,
        " <R:threshold> (kills only weak exc weights)");
  environment->add_cmd("lissom->call_dump_wgts_range_select","lissom",
        &spikelayer2_2::call_dump_wgts_range_select, 6,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <cur_inp> <wgt_select: 0=aff, 1=inh, 2=exc");
  environment->add_cmd("lissom->call_kill_aff_wgt_range","lissom",
        &spikelayer2_2::call_kill_aff_wgt_range, 5,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <cur_inp>");
  environment->add_cmd("lissom->call_kill_lat_exc_wgt_range","lissom",
        &spikelayer2_2::call_kill_lat_exc_wgt_range, 4,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row>");
  environment->add_cmd("lissom->call_kill_instar_lat_exc_wgt_range","lissom",
        &spikelayer2_2::call_kill_instar_lat_exc_wgt_range, 4,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row>");

  // map2
  environment->add_obj("lissom2",map2,"slissom layer2");
  environment->add_alias("slissom2","lissom2");

  environment->add_cmd("lissom2->call_resize_lat_exc_rad","lissom2",
	&spikelayer2_2::call_resize_lat_exc_rad, 1, 
	" <I:radius>");
  environment->add_cmd("lissom2->call_resize_lat_inh_rad","lissom2",
	&spikelayer2_2::call_resize_lat_inh_rad, 1, 
	" <I:radius>");
  environment->add_cmd("lissom2->call_update_sig","lissom2",
        &spikelayer2_2::call_update_sig, 2,
        " <R:sig_low> <R:sig_high>");
  environment->add_cmd("lissom2->call_dump_wgts_range","lissom2",
        &spikelayer2_2::call_dump_wgts_range, 4,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row>");
  environment->add_cmd("lissom2->call_dump_wgt_sums_range","lissom2",
        &spikelayer2_2::call_dump_wgt_sums_range, 4,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row>");
  environment->add_cmd("lissom2->call_kill_lat_weights","lissom2",
        &spikelayer2_2::call_kill_lat_weights, 1,
        " <R:threshold> (kills only weak exc weights)");
  environment->add_cmd("lissom2->call_dump_wgts_range_select","lissom2",
        &spikelayer2_2::call_dump_wgts_range_select, 6,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <cur_inp> <wgt_select: 0=aff, 1=inh, 2=exc>");
  environment->add_cmd("lissom2->call_kill_aff_wgt_range","lissom2",
        &spikelayer2_2::call_kill_aff_wgt_range, 5,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <cur_inp>");
  environment->add_cmd("lissom2->call_kill_lat_exc_wgt_range","lissom2",
        &spikelayer2_2::call_kill_lat_exc_wgt_range, 4,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row>");
  environment->add_cmd("lissom2->call_kill_instar_lat_exc_wgt_range","lissom2",
        &spikelayer2_2::call_kill_instar_lat_exc_wgt_range, 4,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row>");


  // input_spec_list 
  environment->add_cmd( "call_add_spec_rect",&call_add_spec_rect, 3,
        " <I:cx> <I:cy> <I:radius>");

  environment->add_cmd( "call_add_spec_ori_gaus",&call_add_spec_ori_gaus, 5,
        " <I:cx> <I:cy> <R:sigmax> <R:sigmay> <R:angle>");

  environment->add_cmd( "call_clear_spec",&call_clear_spec, 0,
        " ");

  environment->add_cmd( "call_clear_mua_spec",&call_clear_mua_spec, 0,
        " ");

  environment->add_cmd( "call_set_additive",&call_set_additive, 0,
        " ");

  environment->add_cmd( "call_reset_additive",&call_reset_additive, 0,
        " ");

  // simenv mua spec 
  environment->add_cmd( "call_add_mua_spec_circle",&call_add_mua_spec_circle, 3,
        " <I:cx> <I:cy> <I:cradius>");

  environment->add_cmd( "call_add_mua_spec_circle2",&call_add_mua_spec_circle2, 3,
        " <I:cx> <I:cy> <I:cradius>");

  environment->add_cmd( "call_add_mua_spec_bbox",&call_add_mua_spec_bbox, 4,
        " <I:x1> <I:y1> <I:x2> <I:y2>");

  environment->add_cmd( "call_add_mua_spec_sqr",
	&call_add_mua_spec_sqr, 3,
        " <I:cx> <I:cy> <I:radius>");

  // save_or_pref
  environment->add_cmd( "save_or_pref",&save_or_pref, 1, "<I:map_num-1or2>");
  environment->add_cmd( "save_or_prefs",&save_or_prefs, 0, "");

  // save_cog
  environment->add_cmd( "save_cog",&save_cog, 0, "");

  // dump weights
  environment->add_cmd( "dump_affw",&dump_affw, 0, "");
  environment->add_cmd( "dump_excw",&dump_excw, 0, "");
  environment->add_cmd( "dump_inhw",&dump_inhw, 0, "");

  // dump_wgt_or_histo
  environment->add_cmd("lissom->call_dump_wgt_or_histo","lissom",
        &spikelayer2_2::call_dump_wgt_or_histo, 5,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <thresh>");
  environment->add_cmd("lissom2->call_dump_wgt_or_histo","lissom2",
        &spikelayer2_2::call_dump_wgt_or_histo, 5,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <thresh>");

  environment->add_cmd("lissom->call_dump_wgt_or_histo_weighted","lissom",
        &spikelayer2_2::call_dump_wgt_or_histo_weighted, 5,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <thresh>");
  environment->add_cmd("lissom2->call_dump_wgt_or_histo_weighted","lissom2",
        &spikelayer2_2::call_dump_wgt_or_histo_weighted, 5,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <thresh>");

  environment->add_cmd("lissom->call_dump_wgt_or_stat","lissom",
        &spikelayer2_2::call_dump_wgt_or_stat, 5,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <thresh>");
  environment->add_cmd("lissom2->call_dump_wgt_or_stat","lissom2",
        &spikelayer2_2::call_dump_wgt_or_stat, 5,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <thresh>");

  environment->add_cmd("lissom->call_dump_wgt_or_stat_limite_angle","lissom",
        &spikelayer2_2::call_dump_wgt_or_stat_limited_angle, 7,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <thresh> <low_angle> <high_angle>");
  environment->add_cmd("lissom2->call_dump_wgt_or_stat_limited_angle","lissom2",
        &spikelayer2_2::call_dump_wgt_or_stat_limited_angle, 7,
        " <I:start_col> <I:start_row> <I:end_col> <I:end_row> <thresh> <low_angle> <high_angle>");

  // plot matrix
  environment->add_cmd("lissom->call_plot_matrix","lissom",
        &spikelayer2_2::call_plot_matrix, 1,
        " <matrix_name>");
  environment->add_cmd("lissom2->call_plot_matrix","lissom2",
        &spikelayer2_2::call_plot_matrix, 1,
        " <matrix_name>");

  environment->add_cmd("lissom->call_plot_stat","lissom",
        &spikelayer2_2::call_plot_stat, 2,
        " <I:col> <I:row>");
  environment->add_cmd("lissom2->call_plot_stat","lissom2",
        &spikelayer2_2::call_plot_stat, 2,
        " <I:col> <I:row>");
  // save bb image
  environment->add_cmd( "save",&call_save, 0, "");

  // 2.4 execute init_hooks before proceeding
  environment->run_hooks_init();


  //
  // 3. init weights
  //

  //--------------------
  // 3.1 MAP1
  //--------------------
  cerr << "slissom2-2: setup() - initializing map1 weights" << endl;
  map->init_weights(0.0,randomness);

  // 00Nov5 : by default, use RF_RAD. If aff_setup_decay is defined,
  // use that. Default value of aff_setup_decay is -1.0.
  if (aff_setup_decay>0.0) {
  	map->setup_weight(NETWGT_AFF,(REAL)aff_setup_decay,randomness);
  } else {
  	map->setup_weight(NETWGT_CIRCULAR_AFF,(int)RF_RAD,randomness);
  }
  if (circular_intra_columnar_rf_flag==1) { // 01jun20
	map->setup_weight(NETWGT_CIRCULAR_AFF,(int)CF_RAD,randomness,1);
  }

  if (uniform_wgt_flag==1) {
    cerr << "*** MAP1: uniform_wgt_flag = 1" << endl;
    map->setup_weight(NETWGT_INH,(int)INH_RAD,randomness);
    map->setup_weight(NETWGT_EXC,(int)EXC_RAD,randomness);
  } else {
    cerr << "*** MAP1: uniform_wgt_flag = 0" << endl;
    map->setup_weight(NETWGT_INH,(REAL)lat_inh_setup_decay,randomness);
    map->setup_weight(NETWGT_EXC,(REAL)lat_exc_setup_decay,randomness);
  }

  //--------------------
  // 3.2 MAP2
  //--------------------
  cerr << "slissom2-2: setup() - initializing map2 weights" << endl;
  map2->init_weights(0.0,randomness);

  map2->setup_weight(NETWGT_CIRCULAR_AFF,(int)RF_RAD2,randomness);

  if (circular_intra_columnar_rf_flag==1) { // 01jun20
	map2->setup_weight(NETWGT_CIRCULAR_AFF,(int)CF_RAD2,randomness,1);
  }

  if (uniform_wgt_flag==1) {
    cerr << "*** MAP2: uniform_wgt_flag = 1" << endl;
    map2->setup_weight(NETWGT_INH,(int)INH_RAD2,randomness);
    map2->setup_weight(NETWGT_EXC,(int)EXC_RAD2,randomness);
  } else {
    cerr << "*** MAP2 : uniform_wgt_flag = 0" << endl;
    map2->setup_weight(NETWGT_INH,(REAL)(lat_inh_setup_decay),randomness);
    map2->setup_weight(NETWGT_EXC,(REAL)(lat_exc_setup_decay),randomness);
  }
  // map->kill_overlapping_inh_w();
  cerr << "slissom2-2: setup() - map initialization complete : normalizing" << endl;
  if (instar_norm) {
	cerr << "Instar normalization" << endl;
  	map->normalize_instar_weights();
  	map2->normalize_instar_weights();
  } else {
  	map->normalize_weights();
  	map2->normalize_weights();
  }
  cerr << "slissom2-2: setup() - normalizing complete " << endl;
  
  // 
  // 4. set up ideal grid and COG matrix : todo -- this may go into netlayer
  //	class
  //
  
  // 4.1 Ideal grid : MAP1 
  ideal = new coord* [N];
  for (int i=0; i<N; ++i) 
	ideal[i] = new coord [N];

  REAL mag, offsetx, offsety;

  if (padded_flag) {
	mag = (M-2*map->aff_rads[0])/(REAL)N;
	offsetx = offsety = map->aff_rads[0];
  } else {
	mag = M/(REAL)N;
	offsetx = offsety = 0.0;
  }
	
  for (int i=0; i<map->cols; ++i) {
    for (int j=0; j<map->rows; ++j) {
       ideal[i][j].x = (REAL) i*mag + offsetx;
       ideal[i][j].y = (REAL) j*mag + offsety;
    }
  }

  // 4.2 Ideal grid : MAP2
  ideal2 = new coord* [N2];
  for (int i=0; i<N2; ++i) 
	ideal2[i] = new coord [N2];

  if (padded_flag) {
      mag = (M2-2*map2->aff_rads[0])/(REAL)N2;
      offsetx = offsety = map2->aff_rads[0];
  } else {
      mag = M2/(REAL)N2;
      offsetx = offsety = 0.0;
  }

  for (int i=0; i<map2->cols; ++i) {
    for (int j=0; j<map2->rows; ++j) {
       ideal2[i][j].x = (REAL) i*mag + offsetx;
       ideal2[i][j].y = (REAL) j*mag + offsety;
    }
  }


}
//----------------------------------------------------------------------------
void tcl_setup(char *cmdstr, char *configfile) {
	setup(cmdstr,configfile);
}


//----------------------------------------------------------------------------
//      run() 
//        - bplayer : run a certain number of learning steps
//----------------------------------------------------------------------------
/* OBSOLETE -- see tcl_run() 
void run () { // OBSOLETE -- see tcl_run()

}
END comment run() */

//----------------------------------------------------------------------------
//      Tcl interfaces
//----------------------------------------------------------------------------

void tcl_list_variables() {

  if (iters_per_run > 1) {
  cout << "environment->list_scalar() <<<<<<<<<<<<<<<<<<<<<<<<<<<<" << endl;
  environment->list_scalar();
  cout << "map->net_bb->list_scalar() <<<<<<<<<<<<<<<<<<<<<<<<<<<<" << endl;
  map->net_bb->build_hash();
  map->net_bb->list_scalar();
  map->net_bb->destroy_hash();
  }

}

//----------------------------------------------------------------------------
void tcl_setup_input(int i) {

    REAL cur_or;
    int tmp_coord;

    cur_t = i;

    // Run hooks
    environment->run_hooks_before(i);

    //
    // 1. set input and normalize
    //
    REAL sum=0.0;
    input_generator->clear_input();
  
    if (test_flag) {

	// use the registered input specs for input generation
        input_spec_list->add_inputs();	

    } else {

    	input_generator->clear_input();
	map->clear_activity();

	cur_x = (int)(drand48()*M);
	cur_y = (int)(drand48()*M);

	if (invert_xy_flag==1) {
		cur_x = M-cur_x-1;
		cur_y = M-cur_y-1;
	}

	if (swap_xy_flag==1) {
		tmp_coord = cur_x;
		cur_x = cur_y;
		cur_y = tmp_coord;
	}

	// cur_x and cur_y are now determined.

	if (illusory_input_flag==1) {

	  input_generator->set_type(INP_BLOBS);
	  cur_or = (REAL)(drand48()*360.0);
	  if (rotate_or_flag==1) {
		cur_or = (REAL)((int)(cur_or+45.0)%360);
	  }
    	  input_generator->add_input(cur_x,cur_y,
			(REAL)sigmax,cur_or);

	} else if (hemifield_curvature_flag==1) {

	  // this is an ugly hack: 03jan11

	  cur_or=(REAL)(drand48()*360.0);

	  // if (rotate_or_flag==1) {
	  //	cur_or = (REAL)((int)(cur_or+45.0)%360);
	  // }

	  // select curvature
	  REAL curv = (REAL)(drand48());
	  curv *= (cur_y>M/2)
			?upper_hemifield_curvature:lower_hemifield_curvature;

	  // center location
	  int cx = cur_x;
	  int cy = cur_y;
	  REAL ori = cur_or;

	  REAL pi = M_PI;

	  REAL x = sigmax/3.0;

	  // calculate orientations in radian 
	  REAL curv_rad = curv/180.0*pi;
	  REAL ori_rad = ori/180.0*pi;

	  REAL cxo = x + x * cos(curv_rad);
	  REAL cyo = x * sin(curv_rad);

	  REAL cx1 = cos(-ori_rad) * cxo + sin(-ori_rad) * cyo;
	  REAL cy1 = -sin(-ori_rad) * cxo + cos(-ori_rad) * cyo;

	  cx1 = (REAL)cx+cx1;
	  cy1 = (REAL)cy+cy1;

	  // set the correct cx location for the 2nd segment
	  cxo = -cxo;

	  REAL cx2 = cos(-ori_rad) * cxo + sin(-ori_rad) * cyo; 
	  REAL cy2 = -sin(-ori_rad) * cxo + cos(-ori_rad) * cyo;

	  cx2 = (REAL)cx+cx2;
	  cy2 = (REAL)cy+cy2;

     	  input_generator->add_input(cur_x,cur_y,
			(REAL)(sigmax/3.0), (REAL)sigmay, ori);
   	  input_generator->add_input((int)cx1,(int)cy1,
			(REAL)(sigmax/3.0), (REAL)sigmay, ori+curv);
     	  input_generator->add_input((int)cx2,(int)cy2,
			(REAL)(sigmax/3.0), (REAL)sigmay, ori-curv);

	} else if (sigmax>0.01) {
	  cur_or=(REAL)(drand48()*360.0);
	  if (rotate_or_flag==1) {
		cur_or = (REAL)((int)(cur_or+45.0)%360);
	  }
    	  input_generator->add_input(cur_x,cur_y,
			(REAL)sigmax, (REAL)sigmay, cur_or);
	} else {
    	  input_generator->add_input(cur_x,cur_y,1);
	}

	cout << "cur_input: " << cur_x << " " << cur_y << " " << cur_or << endl;

        if (scaleup>1.0) 
		matrix<REAL>::scaleup(input->output,M,M,scaleup);

	if (clear_upper_hemisphere_flag) {
		if (drand48()<clear_upper_hemisphere_prob) {
		   if (clear_input_rows_begin < 0 && clear_input_rows_end < 0) {
			cout << "clear_upper_hemisphere" << endl;
			input_generator->clear_rows();
		   } else if (clear_input_rows_begin >=0 && 
				clear_input_rows_end > clear_input_rows_begin) {
			cout << "clear_input_rows" << endl;
			input_generator->clear_rows(clear_input_rows_begin,
				clear_input_rows_end);
		   } else {
			cout << "error: clear_input_rows failed." << endl;
		   }
		}
	}

    }

    if (0) {
  	  input_generator->clear_input();
    }
 
#   ifndef LissomCUI
    if (i%disp_rate==0) { inpw->redraw(); XFlush(display); }
#   endif

    // clear map activity
    // map->reset_output();
}

//----------------------------------------------------------------------------
void tcl_settle_one_iter(int i, int k) {


	if (test_flag) {
	  if (i==t) { // first activation in the testing run : get new theta
		// new theta is calculated only when auto_theta_flag is on.
		map->activate(0);
		map2->activate(0); 
		// dump input to file 
		input->dump_matrix("output",0);
	  } else {
		map->activate(1);
		map2->activate(1); 
	  }
 	} else {    // training run : get new theta when k==0
	  if (k==0) {
		cerr << "t=" << cur_t << " "; 
		map->reset_neurons();
		map2->reset_neurons();
	  }
	  map->activate(k); 
	  map2->activate(k); 
	}



	// display
        if (i%disp_rate==0) {
		// calculate c.o.g.  
		map->calc_cog(0); 
		map2->calc_cog(0);
#	    	ifndef LissomCUI
		nw->redraw(); 
		mw->redraw(); 
		nw2->redraw();
		matw->redraw();
		matw2->redraw();
  		orw->redraw();
  		orw2->redraw();
		disp_spikes(hsv_spike_flag,test_flag);
#	    	else
		if (k==0) { cout << "iter " << i << endl; }
		disp_spikes(hsv_spike_flag,test_flag);
#	    	endif
	}	
#       ifndef LissomCUI
	set_color(white); 
	XFillRectangle(display,mw->Win,gc_copy,
		0,mw->height-20,mw->width,20);	
        char str[100];
	set_color(black); sprintf(str,"settle=%d",k);
	mw->DrawString(0,mw->height-10,str); sprintf(str,"iter=%d",i);
	mw->DrawString(0,mw->height,str); XFlush(display);
    	if (i%disp_rate==0) {
    		avgw->redraw(); avgw2->redraw(); XFlush(display);
    	}
        for (int c=0; c<stats->get_num_specs(); ++c) {
	   matw->draw_circle(stats->get_cx(c),stats->get_cy(c),
		stats->get_cradius(c),1.0);
	   spikew->draw_circle(stats->get_cx(c),stats->get_cy(c),
		stats->get_cradius(c),1.0);
        }
#   endif
	
	// dump ppm matrices for demo
	if (dump_demo_flag) {
		map2->dump_matrix("spikeact_q",i);
		map2->dump_matrix("net_exc_input",i);
	}
	if (dump_demo_map1_flag) {
		map->dump_matrix("spikeact_q",i);
		map->dump_matrix("net_exc_input",i);
	}

}
//----------------------------------------------------------------------------
void tcl_learn_and_normalize(int i) {
    // learn weights
    map->learn();
    map2->learn();

    if ((delayed_normalization_flag>0)&&(i%delayed_normalization_flag==0)) {
	    if (instar_norm) {
	    	cerr << "Normalizing : instar" << endl;
		map->normalize_instar_weights();
		map2->normalize_instar_weights();
	    } else {
	    	cerr << "Normalizing : outstar" << endl;
		map->normalize_weights();
		map2->normalize_weights();
	    }
    }

}

//----------------------------------------------------------------------------
void tcl_clear_activity() {

      map->clear_activity();
      map2->clear_activity();

}
//----------------------------------------------------------------------------
void tcl_run_hooks_after(int i) {

    environment->run_hooks_after(i);

}
//----------------------------------------------------------------------------
void tcl_log_and_save_cog_and_weights(int i) {

  char str[100];
  char cog_fname[256];

    // log every 1000 iterations
    if (i%disp_rate==0) {
	netlog->append("iter %d reached.",i);
    }

    if (i%wgt_disp_rate==0 && i!=0) {
	// plot afferent weights if specified.
	// calculate and save or maps
	affdisp();
	// save center of gravity plots
	map->calc_cog(0);
  	sprintf(cog_fname,
       		"%s%06d.map1-0.cog",
        	filename::swap_ext(buffname,conffilename,""),
		cur_t);
	map->save_cog(0,cog_fname);
	map2->calc_cog(0);
  	sprintf(cog_fname,
       		"%s%06d.map2-0.cog",
        	filename::swap_ext(buffname,conffilename,""),
		cur_t);
	map2->save_cog(0,cog_fname);
    }

    if (i%save_rate==0 && i!=0) {
      char imgbasename[200];
      char curimgfile[200];
      filename::swap_ext(imgbasename,conffilename,"");
      sprintf(curimgfile,"%s%d-map1.sav",imgbasename,i);
      map->net_bb->build_hash();
      map->net_bb->save(curimgfile);
      map->net_bb->destroy_hash();
      sprintf(curimgfile,"%s%d-map2.sav",imgbasename,i);
      map2->net_bb->build_hash();
      map2->net_bb->save(curimgfile);
      map2->net_bb->destroy_hash();
    }
}

//----------------------------------------------------------------------------
//	tcl_run : test if all components defined for use in tcl works
//----------------------------------------------------------------------------
void tcl_run() {

  int i;

  tcl_list_variables();

  // for the number of given steps
  for (i=t; i<t+iters_per_run; ++i) {

    tcl_setup_input(i);

    // activate and settle
    int settling = test_flag ? 1 : tsettle;
    for (int k=0; k<settling ; ++k) {

	tcl_settle_one_iter(i,k);

    } // end of settling loop

    tcl_learn_and_normalize(i);

    // clear the map activity
    if (!test_flag) {
	tcl_clear_activity();
    }

    // Run hooks
    tcl_run_hooks_after(i);
    
    // log, and save cog and weights

    tcl_log_and_save_cog_and_weights(i);


  } // end of big loop

  // set start of next run
  t = i;

}

//----------------------------------------------------------------------------
//	test() 
//	  - testing mode
//----------------------------------------------------------------------------
void test() {

  cerr << "Entering Test mode ***\n";
  test_flag = 1;

  tcl_run();

}

//----------------------------------------------------------------------------
//	save() 
//	  - save blackboard
//----------------------------------------------------------------------------
void save() {

  cout << "lissom.cc: saveit() : saving to lissom.sav\n";
  char imgbasename[200];
  char curimgfile[200];
  filename::swap_ext(imgbasename,conffilename,"");
  sprintf(curimgfile,"%s%d-map1.sav",imgbasename,cur_t);
  map->net_bb->build_hash();
  map->net_bb->save(curimgfile);
  map->net_bb->destroy_hash();
  sprintf(curimgfile,"%s%d-map2.sav",imgbasename,cur_t);
  map2->net_bb->build_hash();
  map2->net_bb->save(curimgfile);
  map2->net_bb->destroy_hash();

}
//----------------------------------------------------------------------------
int call_save(int argc, char *argv[]) {

  save();

  return 1;
}

//----------------------------------------------------------------------------
//	dump_affw() 
//	  - dump afferent weights
//----------------------------------------------------------------------------
int dump_affw(int argc, char *argv[]) {

  dump_selectw(0);

  return 1;

}
//----------------------------------------------------------------------------
int dump_excw(int argc, char *argv[]) {

  dump_selectw(2);

  return 1;

}
//----------------------------------------------------------------------------
int dump_inhw(int argc, char *argv[]) {

  dump_selectw(1);

  return 1;

}
//----------------------------------------------------------------------------
void dump_selectw(int select) {

  char argv_mat[7][100];
  char *argv[7];
  int  start,end;

  for (int i=0; i<7; ++i) {
	argv[i] = argv_mat[i];
  }
  
  start = N/2-10; 	if (start<0) start=0;
  end 	= start + 20; 	if (end>=N) end=N-1;
  cout << "dump_selectw: map1 dumping from " << start << " to " << end << endl;
  sprintf(argv[1],"%d",start);
  sprintf(argv[2],"%d",start);
  sprintf(argv[3],"%d",end);
  sprintf(argv[4],"%d",end);
  sprintf(argv[5],"%d",0);
  sprintf(argv[6],"%d",select);
  map->call_dump_wgts_range_select(6,argv);

  system("mv dump.w dump1.w");

  start = N2/2-10; 	if (start<0) start=0;
  end 	= start + 20; 	if (end>=N2) end=N2-1;
  cout << "dump_selectw: map2 dumping from " << start << " to " << end << endl;
  sprintf(argv[1],"%d",start);
  sprintf(argv[2],"%d",start);
  sprintf(argv[3],"%d",end);
  sprintf(argv[4],"%d",end);
  sprintf(argv[5],"%d",0);
  sprintf(argv[6],"%d",select);
  map2->call_dump_wgts_range_select(6,argv);
  system("mv dump.w dump2.w");
 
}

#ifndef LissomCUI
//----------------------------------------------------------------------------
//	alloc_affdisp() 
//	  - allocate weights as necessary
//----------------------------------------------------------------------------
void alloc_affdisp() {
  
  static int alloced = 0;

  // weight display

  if (alloced == 0 || alloced != wgt_disp_flag) {

  switch(wgt_disp_flag) {
  case 0 : break;
  case 5 :
  case 1 : affdispw = new affw_window("Afferent weight", map,
                        N*(M+1)*WGT_GRAN,N*(M+1)*WGT_GRAN);
         break;
  case 15 : affdispw = new affw_window("Afferent weight", map2,
                        N2*(M2+1)*WGT_GRAN,N2*(M2+1)*WGT_GRAN);
         break;
  case 6:
  case 2 : latinhdispw = new latw_window("Lateral inh weight",map,
                        N*(N+1)*WGT_GRAN,N*(N+1)*WGT_GRAN,
                      LATW_INH,10.0,0); 
	 break;
  case 7 : /* latexcdispw = new latw_window("Lateral exc weight (map2)",map2,
                        N2*(N2+1)*WGT_GRAN,N2*(N2+1)*WGT_GRAN,
                      LATW_EXC,10.0); 
         break; */
  case 3 : latexcdispw = new latw_window("Lateral exc weight",map,
                        N*(N+1)*WGT_GRAN,N*(N+1)*WGT_GRAN,
                        LATW_EXC,10.0);
         break;
  case 4 : latcombdispw = new latw_window("Combined lateral weight",map,
                        N*(N+1)*WGT_GRAN,N*(N+1)*WGT_GRAN,
                        LATW_COMB,10.0);
	 break;
  case 23: // both lat and exc
	 latinhdispw = new latw_window("Lateral inh weight",map,
                        N*(N+1)*WGT_GRAN,N*(N+1)*WGT_GRAN,
                      LATW_INH,10.0,0);
	 latexcdispw = new latw_window("Lateral exc weight",map,
                        N*(N+1)*WGT_GRAN,N*(N+1)*WGT_GRAN,
                        LATW_EXC,10.0);
         break;
   }// end switch

   alloced = wgt_disp_flag;

  }
}
#endif
//----------------------------------------------------------------------------
//	plotstat() 
//	  - plot stat using call_plot_stat
//----------------------------------------------------------------------------
void plotstat() {
	
	char *args[2];
	args[0] = new char[50];
	args[1] = new char[50];
	
   	sprintf(args[0],"%d",N/2);
   	sprintf(args[1],"%d",N/2);
	map->call_plot_stat(2,args);

   	sprintf(args[0],"%d",N2/2);
   	sprintf(args[1],"%d",N2/2);
	map2->call_plot_stat(2,args);

	delete [] args[0];
	delete [] args[1];

}

//----------------------------------------------------------------------------
//	affdisp() 
//	  - popup and display afferent weights
//----------------------------------------------------------------------------
void affdisp() {

  static int toggled=0;
  char	or_fname[256];

#ifndef LissomCUI
  alloc_affdisp();
  switch(wgt_disp_flag) {
  case 0: break;
  case 5:
  case 15:
  case 1: affdispw->set_scale(wgt_disp_scale); break;
  case 6: 
  case 2: latinhdispw->set_scale(wgt_disp_scale); break;
  case 7:
  case 3: latexcdispw->set_scale(wgt_disp_scale); break;
  case 8:
  case 4: latcombdispw->redraw(); break;
  case 23: latinhdispw->set_scale(wgt_disp_scale);
	   latexcdispw->set_scale(wgt_disp_scale); break;
  }

  if (!toggled) {
      switch(wgt_disp_flag) {
      case 0: break;
      case 5:
      case 15:
      case 1: affdispw->toggle(); break;
      case 6:
      case 2: latinhdispw->toggle();break;
      case 7:
      case 3: latexcdispw->toggle();break;
      case 4: latcombdispw->toggle();break;
      case 23: latinhdispw->toggle(); latexcdispw->toggle();break;
      }
      toggled=1;
  } else {
      switch(wgt_disp_flag) {
      case 0: break;
      case 5:
      case 15:
      case 1: affdispw->redraw(); break;
      case 6:
      case 2: latinhdispw->redraw(); break;
      case 7:
      case 3: latexcdispw->redraw(); break;
      case 4: latcombdispw->redraw(); break;
      case 23: latinhdispw->redraw(); latexcdispw->redraw(); break;
      }
  }	

#endif

  if (wgt_disp_flag < 5) {

  // map2 inter-area ----------------------------------------------------
  map2->calc_or_pref(1,sigmax/2.0,sigmay/2.0);
  sprintf(or_fname,
       "%s%06d.map2-1.or",
       filename::swap_ext(buffname,conffilename,""),
       cur_t);
  map2->save_or_pref(1,or_fname);
  // map2->print_or_pref();
  // repeat_print("0 ",N);

  // map2 aff ----------------------------------------------------
  map2->calc_or_pref(0,sigmax/2.0,sigmay/2.0);
  map2_or->import_matrix(map2->or_pref);
  sprintf(or_fname,
       "%s%06d.map2-0.or",
       filename::swap_ext(buffname,conffilename,""),
       cur_t);
  map2->save_or_pref(0,or_fname);
  sprintf(or_fname,
       "%s%06d.map2-0.orselec",
       filename::swap_ext(buffname,conffilename,""),
       cur_t);
  map2->save_or_selectivity(0,or_fname);
  // map2->print_or_pref();
  // repeat_print("0 ",N2);

  // map1 inter-area ----------------------------------------------------
  map->calc_or_pref(1,sigmax/2.0,sigmay/2.0);
  sprintf(or_fname,
       "%s%06d.map1-1.or",
       filename::swap_ext(buffname,conffilename,""),
       cur_t);
  map->save_or_pref(1,or_fname);
  // map->print_or_pref();
  // repeat_print("0 ",N);

  // map1 aff ----------------------------------------------------
  map->calc_or_pref(0,sigmax/2.0,sigmay/2.0);
  map1_or->import_matrix(map->or_pref);
  sprintf(or_fname,
       "%s%06d.map1-0.or",
       filename::swap_ext(buffname,conffilename,""),
       cur_t);
  map->save_or_pref(0,or_fname);
  sprintf(or_fname,
       "%s%06d.map1-0.orselec",
       filename::swap_ext(buffname,conffilename,""),
       cur_t);
  map->save_or_selectivity(0,or_fname);
  // map->print_or_pref();
  // repeat_print("0 ",N);

  }

#ifndef LissomCUI
  orw->redraw();
  orw2->redraw();
#endif

}

//----------------------------------------------------------------------------
//	tcl_command() 
//	  - read input and run command
//----------------------------------------------------------------------------
void tcl_command() { 	

  char *command;

  cerr << "slissom command shell : type 'quit' to end command session."<< endl;
  cerr << "slissom> " << endl;
  command = readline("slissom> "); 
  while ((command!=NULL)&&(strncmp(command,"return",6)!=0)) {
	add_history(command);
	// check if it is a local command
	if (strncmp(command,"train",5)==0) {
		tcl_run();
	} else if (strncmp(command,"disp_wgt",8)==0) {
		affdisp();
	} else if (strncmp(command,"save",4)==0) {
		save();
	} else if (strncmp(command,"test",4)==0) {
		cerr << "Entering TEST mode: will exit when done.\n";
		test();
		break;
	} else if (strncmp(command,"exit",4)==0) {
		cerr << "Exiting.\n";
		exit(0);
	} else {	
		environment->parse(command);
	}
	if (command) free(command);
  	command = readline("slissom> "); 
	
  }
  if (command) free(command);

}

/*
//----------------------------------------------------------------------------
//	command() 
//	  - read input and run command
//----------------------------------------------------------------------------
void tcl_command(char *command) { // OBSOLETE

}
*/

//----------------------------------------------------------------------------
//	handler() 
//	  - handle SIGINT and give command prompt
//----------------------------------------------------------------------------
void handler(int stat) {

  cout << "SIGINT received. Entering command mode." << endl;
  tcl_command();
  signal(SIGINT,handler);

}

#ifndef LissomCUI
//----------------------------------------------------------------------------
//	gdb_dispmat() 
//	  - for debugging, display arbirtaty map
//----------------------------------------------------------------------------
void gdb_dispmat(REAL **mat, int cols, int rows, int gran) {

  disputil_window *dw = new disputil_window("gdb vis",mat,rows,cols,gran);
  unmap_button *dwclose = new unmap_button(*dw,"close",cols*gran,20,0,rows*gran);  
  dw->toggle();

}
#endif

#ifndef LissomTcl
//----------------------------------------------------------------------------
//	main() 
//	  - the MAIN
//----------------------------------------------------------------------------
int main(int argc, char *argv[]) {


  signal(SIGINT, handler);

  steps = 20000;
  t 	= 0;

  cout << "Debug mode = " << DEBUG << endl;

  // 0. start the readline history feature
  using_history();

  // 1. check args
  if (argc < 2) {
	cout << "usage: " << argv[0] 
	     << " <configfilename> [<network imagefile1> <network imagefile2> <start t> [<ormap1 filename> <ormap2 filename>]]\n";
 	exit(0);
  } 

  // 1.1 save config filename
  strncpy(conffilename,argv[1],strlen(argv[1])+1);

  // 2.1 setup network and allocate memory

  cerr << "slissom2-2: entering network setup()" << endl;
  setup(argv[0],argv[1]);
  cerr << "slissom2-2: network setup() complete" << endl;

  spikeact = new REAL* [N];
  for (int i=0; i<N; ++i) spikeact[i] = new REAL [N];

  spikeact2 = new REAL* [N2];
  for (int i=0; i<N2; ++i) spikeact2[i] = new REAL [N2];

  // 2.2. setup input generator
  input_generator = new geninput(input->output,M,M,INP_ORI_BAR,INP_NORM_NONE);
  input_generator->clear_input();

  // initialize inputlist object -- this is used in setup().
  input_spec_list = new inputlist(20,input_generator);

  // initialize inputstats in case rerun-hook is executed
  stats       = new simstat(spikeact, N, N,20);
  stats2       = new simstat(spikeact2, N2, N2,20);

  // 2.3 if network imagefilename given, load the network image
  if (argc >= 5) {
	
	cout << "slissom2-2 : main() : setting t = " << argv[4] << "\n";
	t = atoi(argv[4]);
	// now go through all hooks so that the simulation environment
	// is the same as when the image was saved
        cout << "slissom2-2 : main() : redoing all hooks " << endl;
	environment->rerun_hooks(t-1);	
        cout<< "slissom2-2 : main() : redone all hooks " << endl;

	cout << "slissom2-2 : main() : loading image 1 - " << argv[2] << "\n";
	map->net_bb->build_hash();
	map->net_bb->load(argv[2]);
	map->net_bb->destroy_hash();

	cout << "slissom2-2 : main() : loading image 2 - " << argv[3] << "\n";
	map2->net_bb->build_hash();
	map2->net_bb->load(argv[3]);
	map2->net_bb->destroy_hash();
	cout << "slissom2-2 : main() : loading complete " << argv[3] << "\n";

  }

  map1_or = new matrix<REAL>(N,N);
  map2_or = new matrix<REAL>(N2,N2);
  map1_or_selectivity = new matrix<REAL>(N,N);
  map2_or_selectivity = new matrix<REAL>(N2,N2);

  // 2.4 Load saved ormap if one is specified
  if (argc==7) {
	// set hsv_spike_flag by default
	// hsv_spike_flag = 1; // disable -- 01feb6 : this causes
	//				mua calculation to screw up
	cerr << "slissom2-2: loading map1 ormap" << endl;
	map1_or->load_real_matrix(argv[5]);
	map1_or->export_matrix(map->or_pref);
	cerr << "slissom2-2: loading map2 ormap" << endl;
	map2_or->load_real_matrix(argv[6]);
	map2_or->export_matrix(map2->or_pref);
  }

  ppm_spikeact  = new ppmio(spikeact,N,N,256);
  ppm_spikeact2 = new ppmio(spikeact2,N2,N2,256);

# ifndef LissomCUI

  //
  // 4.1. GUI Interface
  //

  // setup the windows
  int maxn = MAX(N,M); 
  int maxn2 = MAX(N2,M2); 
  int x=0, y=0;

  ColMode cm=COLOR;
  if (hsv_spike_flag) cm=HSV_MULT;

  // 4.1.0 Main Window
  mw = new mymain_window(argv[0],
		GRAN*2*(maxn+maxn2)+50,
		GRAN*2*MAX(maxn,maxn2)+100);
  
  // 4.1.1 MAP1

  // netinput
  x = 10; y = 10;
  matw = new matrix_window(*mw,
		maxn*GRAN,maxn*GRAN,
		x,y,
		0,60,COLOR,N,N,map->lfp);  
  matw->register_stat(stats);

  // input
  y += maxn*GRAN+10;
  inpw = new matrix_window(*mw,
		maxn*GRAN,maxn*GRAN,
		x,y,
		0,60,
		COLOR,M,M,input->output);  

  // center-of-gravity plot
  x += maxn*GRAN+10;
  y = 10;
  nw = new net_window(*mw,
		maxn*GRAN,maxn*GRAN,
		x,y,
		0,10,
		COLOR,N,N,0.0,1.0,0.0,1.0,map->cogs[0],ideal);

  // spike window
  y += maxn*GRAN+10;
  spikew = new matrix_window(*mw,
		(int)(maxn*GRAN/2),
		(int)(maxn*GRAN/2)
		,x,y,
		0,60, cm,N,N,spikeact);  

  // ormap window
  orw = new matrix_window(*mw,
		(int)(maxn*GRAN/2),
		(int)(maxn*GRAN/2)
		,x,y+(int)(maxn*GRAN/2)+10,
		0,60, HSV,N,N,map1_or->mat);  

  // time average window
  x += (int)(maxn*GRAN/2)+5;
  avgw   = new matrix_window(*mw,
		(int)(maxn*GRAN/2),(int)(maxn*GRAN/2), 
		x,y,
		0,60,
		COLOR,N,N,map->avg_spiking);  
  avgw->set_scale(2.5);

  // net_aff_input window
  y += (int)(maxn*GRAN/2)+10;
  netaffw   = new matrix_window(*mw,
		(int)(maxn*GRAN/2),(int)(maxn*GRAN/2), 
		x,y,
		0,60,
		COLOR,N,N,map->net_exc_input);  
  netaffw->set_scale(2.5);

  // 4.1.2 MAP2 
  x += (int)(maxn*GRAN/2)+5; 
  y=10;
  // net input
  matw2 = new matrix_window(*mw,
		maxn2*GRAN,maxn2*GRAN,
		x,y,
		0,60,COLOR,N2,N2,map2->lfp);  
  matw2->register_stat(stats2);

  // center-of-gravity plot
  x += maxn2*GRAN+10;
  nw2 = new net_window(*mw,
		maxn2*GRAN,maxn2*GRAN,
		x,y,
		0,10,
		COLOR,N2,N2,0.0,1.0,0.0,1.0,map2->cogs[0],ideal2);

  // spike window
  y += maxn2*GRAN+10;
  spikew2 = new matrix_window(*mw,
		(int)(maxn2*GRAN/2),(int)(maxn2*GRAN/2),
		x,y,
		0,60,cm,N2,N2,spikeact2);  
  spikew2->register_stat(stats2);

  // ormap window
  orw2 = new matrix_window(*mw,
		(int)(maxn2*GRAN/2),(int)(maxn2*GRAN/2),
		x, y+(int)(maxn2*GRAN/2)+10,
		0,60,HSV,N2,N2,map2_or->mat);  

  // time average window
  x += (int)(maxn2*GRAN/2)+5;
  avgw2   = new matrix_window(*mw,
		(int)(maxn2*GRAN/2),(int)(maxn2*GRAN/2), 
		x,y,
		0,60,
		COLOR,N2,N2,map2->avg_spiking);  
  avgw2->set_scale(2.5);

  // net_aff_input window
  y += (int)(maxn2*GRAN/2)+10;
  netaffw2   = new matrix_window(*mw,
		(int)(maxn2*GRAN/2),(int)(maxn2*GRAN/2), 
		x,y,
		0,60,
		COLOR,N2,N2,map2->net_exc_input);  
  netaffw2->set_scale(2.5);

  // 4.1.3 Buttons
  statit = new callback_button(*mw,"Stat",plotstat,
                mw->width/8,20,mw->width*1/8,mw->height-20);

  runit = new callback_button(*mw,"Run",tcl_run,
                mw->width/8,20,mw->width*4/8,mw->height-20);

  saveit = new callback_button(*mw,"Save",save,
		mw->width/8,20,mw->width*5/8,mw->height-20);
 
  testit = new callback_button(*mw,"Test",test,
                mw->width/8,20,mw->width*6/8,mw->height-20);

  affdispit = new callback_button(*mw,"Wgt Disp",affdisp,
                mw->width/8,20,mw->width*3/8,mw->height-20);

  commandit = new callback_button(*mw,"Cmd",tcl_command,
                mw->width/8,20,mw->width*2/8,mw->height-20);

  new quit_button(*mw,mw->width/8,20,mw->width*7/8,mw->height-20);

  matw->redraw();
  matw2->redraw();
  nw->redraw();
  nw2->redraw();

  // start main loop
  mw->main_loop();

  // after exiting from main loop, deallocate stuff
  for (int i=0; i<N; ++i) delete [] spikeact[i];
  delete [] spikeact;
  for (int i=0; i<N2; ++i) delete [] spikeact2[i];
  delete [] spikeact2;

# else

  // 4.2 If this is a continuation of previous simulation, 
  //	bring up command prompt.
  cerr << "** STARTING UP COMMAND PROMPT: enter \"return\" to start"
		<< endl;
  tcl_command(); 

  //
  // 4.3. Text interface
  //
  // tcl_run(); --- you can now run train or test in the command
  //	interface

  // save();

# endif

  cerr << "Exiting program" << endl;
  delete netlog;

}

#endif
