## Copyright (C) 2000 uschoe
##
## This file is part of Octave.
##
## Octave is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2, or (at your option)
## any later version.
##
## Octave is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Octave; see the file COPYING.  If not, write to the Free
## Software Foundation, 59 Temple Place - Suite 330, Boston, MA
## 02111-1307, USA.

## usage: circle(R)
##
## Returns a 2x2R matrix with (x,y) coordinates of a circle.
##

## Author: Yoonsuck Choe <yschoe@cs.utexas.edu>

function c = circle (R)

  # positive portion of the circle
  for i=-R:R ;
	c(1,i+R+1) = i;
	c(2,i+R+1) = sqrt(R**2-i**2);
  endfor

  offset = columns(c);
  # negative portion of the circle
  x = offset+1;
  for i=R:-1:-R ;
	c(1,x) = i;
	c(2,x) = -sqrt(R**2-i**2);
	x = x + 1;
  endfor

endfunction
