# function I = hsvhist(h,r) 
# 	h = [x',n'] r = ratio (e.g. 2/3)

function I = hsvhist(h,ratio)

  # get data
  x = h(:,1);
  n = h(:,2);

  # dimension
  r = rows(x);

  gran = 3;

  aspect = 4;

  # clear matrix
  mat = ones(r*gran,r/aspect*gran);

  max_x = r/aspect*gran;

  xscale = ratio*max_x/max(n);

  # fill in values
  for i=1:r
	width = floor(n(i)*xscale);
	height = gran;
	start_y = (i-1)*gran+1;
	mat(start_y:(start_y+gran-1),1:(width)) = [(ones(height,width)*(1.0-x(i))*255)];
  endfor

  I = mat;

  outline = [zeros(rows(I),1),diff(sign(I-1)')'].^2;
  outline += [zeros(1,columns(I));diff(sign(I.-1))].^2;
  outline += [zeros(1,columns(I));flipud(diff(sign(flipud(I).-1)))].^2;
  outline = sign(outline);

  [rs,cs] = size(I);

  solid = sign(mat-1);
  for i=1:(rs-1)
    for j=1:(cs-1)
	if solid (i,j:j+1) == [1 0]
		mat(i,j+1) = 10;
	endif
    endfor
  endfor;

  solid = sign(mat-1);
  for i=1:(rs-1)
    for j=1:(cs-1)
	if solid (i:i+1,j) == [1;0]
		mat(i+1,j) = 10;
	endif
    endfor
  endfor

  solid = sign(mat-1);
  for i=1:(rs-1)
    for j=1:(cs-1)
	if solid (i:i+1,j) == [0;1]
		mat(i,j) = 10;
	endif
    endfor
  endfor

  I = mat;

endfunction
