//----------------------------------------------------------------------------
// 
//	file: hsvmat5 : full-blown hue-saturation-value input 
// 
//	function: matrix of REAL into HSV ppm 
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Wed Jan  6 00:03:12 CST 1999
// 
//	$Revision: 1.1 $ $Date: 2002/06/20 22:35:52 $
//	$Log: hsvmat4.cc,v $
//	Revision 1.1  2002/06/20 22:35:52  yschoe
//	Initial revision
//
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
// 
//	file: ppmgdbmat.cc
// 
//	function: plot gdbmatrix dump in ppm format
//	author:   Yoonsuck Choe <yschoe@cs.utexas.edu>
//	creation: Thu Nov 26 04:52:52 CST 1998
// 
//	Revision: $ $Date: 2002/06/20 22:35:52 $
//	Log: 
//
//----------------------------------------------------------------------------
#include <iostream.h>
#include <stdio.h>
#include <nnview/ppmio.h>
#include <nnview/matrix.h>
#include <nnview/filename.h>
#include <nnview/real.h>
#include <nnview/hsvrgb.h>

//----------------------------------------------------------------------------
//	usage() 
//	  - prog usage
//----------------------------------------------------------------------------
void usage(int argc) {

  if (argc < 5) { 
    cout  << " usage: hsvmat5 <cols> <rows> <valmult> <outputfile> [<mult>] < stdin " << endl;
    cout  << " 		- uses cartesian coordinate " << endl;
    cout  << " 		- hue-value-max(1-val,sat) as stdin" << endl;
    exit(0);
  }

}

//----------------------------------------------------------------------------
//	draw_bar() 
//	  - fill in given rectangle with a value
//----------------------------------------------------------------------------
void draw_bar(int col, int row, int width, int height,
	REAL value, REAL **dest) {
 

  int start = col*width;
  int start_row = row*height;

  for (int i=start; i<start+width; ++i) 
     for (int j=start_row; j<start_row+height; ++j)
		dest[i][j] = value;

}
  
//----------------------------------------------------------------------------
//	main() 
//	  - the main
//----------------------------------------------------------------------------
int main(int argc, char *argv[]) {

  usage(argc);
	
  FILE *fp;

  int cols = atoi(argv[1]);
  int rows = atoi(argv[2]);
  REAL mult = atof(argv[3]);

  REAL ormult = 1.0;
  if (argc == 6) {
  	ormult = atof(argv[5]);
  } 

  int ppm_width = cols;
  int ppm_height = rows;

  matrix<REAL> *ppm_buff= new matrix<REAL>(ppm_width,ppm_height);
  matrix<REAL> *ppm_buff2= new matrix<REAL>(ppm_width,ppm_height);
  matrix<REAL> *ppm_buff3= new matrix<REAL>(ppm_width,ppm_height);

  ppmio *io = new ppmio(ppm_buff->mat,ppm_buff2->mat,ppm_buff3->mat,ppm_width,ppm_height,256,(REAL)1.0,(REAL)mult);

  // get hue data from stdin
  for (int y=0; y<rows; ++y)
     for (int x=0; x<cols; ++x) {
	cin >> ppm_buff->mat[x][y];
	ppm_buff->mat[x][y] *= ormult;
  }

  // get saturation data
  for (int y=0; y<rows; ++y)
     for (int x=0; x<cols; ++x)
	cin >> ppm_buff2->mat[x][y];
  ppm_buff2->scale();

  // get value data
  for (int y=0; y<rows; ++y)
     for (int x=0; x<cols; ++x)
	cin >> ppm_buff3->mat[x][y];

  ppm_buff3->scale();

  // write matrix to ppm file
  io->ppmwrite(argv[4],0.0,0.0,PPM_HSV);

  delete io;
  delete ppm_buff;

}

