%  function ff = huegrad4(filename)
function ff = huegrad4(im)

    % assume that the or pref matrix "im" contains 
    % values in the range [0.0..1.0].
  
    [r,c]=size(im); 
    dx = diff(im,1);
    dx=dx(1:r-1,1:c-1); 

    dy=diff(im',1)';
    dy=dy(1:r-1,1:c-1); 

    % First convert negative angle to 180+(neg_angle), an equivalent
    % positive angle: this is the same as a sawtooth function.
    dx = dx - floor(dx);
    dy = dy - floor(dy);

    % Then, increase as gradient reachs 90\degree, and decrease from 
    % there on to % 180\degree
    dx = -abs(dx.-0.5) + 0.5;
    dy = -abs(dy.-0.5) + 0.5;

    ff=sqrt(dx.^2+dy.^2);
    imagesc(ff,4);

endfunction

