# function A = lissom1d(act,inp,erad,irad,gammaexc,gammainh,tsettle,beta)
#
#	lissom1d activation
#	   usual values:
#		act : 1d initial activity vector
#		inp : 1d afferent input vector
#		gammaexc = 1.1; gammainh = 1.0; erad=2; irad=5; tsettle=5;
#		beta = 1.0;
#		disp = move sigmoid to +x direction

function A = lissom1d(act,inp,erad,irad,gammaexc,gammainh,tsettle,beta,displ)

	n = length(act);

	x = (1:n); 

	# exc lat conn range
	eend = min(n,(x+erad)); 
	ebegin=max(1,(x-erad)); 
	erange=eend-ebegin.+1; 

	# inhibitory lat conn range
	iend = min(n,(x+irad)); 
	ibegin=max(1,(x-irad)); 
	irange=iend-ibegin.+1; 

	# initial activity
	# act=rand(1,n); 

	esumrange = [ebegin',eend']; 
	isumrange = [ibegin',iend']; 

	# calc weighted sum
	for j=1:tsettle; 
	   # plot(x,weact,x,wiact,x,we,x,wi);
	   #   plot(x,we,x,act,x,weact);
	   for i=1:n; 
	      newact(i) = sigmoid(sum(act(ebegin(i):eend(i))/erange(i))*gammaexc 
				- sum(act(ibegin(i):iend(i))/irange(i))*gammainh 
				+ inp(i)-displ,beta); 
	   endfor; 
	   act=newact'; 
	endfor;

	A = act;

endfunction
