#!/usr/bin/perl

$usage = <<EOF;
usage: reordermua.pl <n> <order> <muafile>

	<n> : number of iterations to plot
	<order> : 

		<n1>:<n2>:<n3>:...

		where n1 n2 n3 are the rows that should go into
		position 1, 2, 3, etc.

	

EOF

if ($#ARGV != 2) {
	print $usage;
	exit;
}

$n = $ARGV[0];

@order = split(/:/,$ARGV[1]);

open(FP,$ARGV[2]);
open(OFP,"> $ARGV[2].reordered");

while (<FP>) {
	chop;
	@mua = split(/[\s]+/,$_);
	$str = "";
	for ($i=0; $i<=$#order; ++$i) {
		$str .= (-$mua[$order[$i]+1])." ";
	} 
	chop $str;
	print OFP $str."\n";
		
}
close(FP);
close(OFP);

`procgraymat $ARGV[2].reordered`;
# need to hflip because procgraymat converts screen coordinate
# into cartesian
`xv -geometry +0+400 -expand 2:20 -rotate 90 -raw -hflip $ARGV[2].reordered.ppm`;

