#!/usr/bin/wish

global win_size max_d d theta phi max_idx
set win_size 413

#----------------------------------------------------------------------------
# 	plotnet: plot c.o.g.s net 
#----------------------------------------------------------------------------
proc plotnet { } {

	global win_size max_d d theta phi max_idx
	
 	set gran [expr $win_size / $max_d / 2.0];
	set centerx [expr $win_size/2.0]
	set centery [expr $win_size/2.0]
	set length [expr $centerx / $max_d / 2.0]

	for {set i 0} {$i<$max_idx} {incr i} {
		if {$phi($i) % 5 == 0 } {
		set rad [expr $phi($i)*3.141592/180.0]
		if {$d($i)==0} {
			set dist  0
		} else  {
			set dist [expr $d($i)+0.25];
		}
			set dist [expr $d($i)+0.25];
		set cx [expr $dist*cos($rad)*$gran+$centerx]
		set cy [expr $centery-($dist*sin($rad)*$gran)]
		set rad_theta [expr $theta($i)*3.141592/180.0]
		set offsetx [expr $length * cos($rad_theta)]
		set offsety [expr $length * sin($rad_theta)]
  		.misc.net create line   \
			[expr $cx-$offsetx/2.0] \
			[expr $cy+$offsety/2.0] \
			[expr $cx+$offsetx/2.0] \
			[expr $cy-$offsety/2.0] \
			-fill \#000000 -width 1 
		}
	}
}


#----------------------------------------------------------------------------
#
# 	MAIN:
#
#----------------------------------------------------------------------------
if {[llength $argv] <= 0} {
  puts "usage: polarlines.tcl <polar-datafile>"
  exit
}

#----------------------------------------
# 1. Load polar data
#----------------------------------------
set fp [open [lindex $argv 0]]

set max_d 0
set idx 0
while {![eof $fp]} {
  
  set line [gets $fp]


  if {[eof $fp]} {
		break
  }
  set phi_d_theta [split $line " "]

  set phi($idx) [lindex $phi_d_theta 0]
  set d($idx) [lindex $phi_d_theta 1]
  set theta($idx) [lindex $phi_d_theta 2]


  # puts "$idx $phi($idx) $d($idx) $theta($idx)"
  if { $d($idx) > $max_d } { 
	set max_d $d($idx)
  }
  
  if { $theta($idx) > 180 } {
      set $theta($idx) [expr $theta($idx)-180]  
  }

  incr idx
}
set max_idx $idx
puts "max_d = $max_d"
close $fp

#----------------------------------------
# 2. Create polar line display window
#----------------------------------------
frame .misc -relief ridge; pack .misc -padx 10 -pady 10

canvas .misc.net -relief sunken -borderwidth 1 -background white \
	-width $win_size -height $win_size;
pack .misc.net -side left -padx 10 -pady 5 ; 

button .psdump -command { \
        .misc.net postscript -file polarlines.ps ; \
        } -text "PS Dump"
pack .psdump -side left

button .quit -command { exit } -text "Quit"
pack .quit -side top -padx 10 -pady 10

plotnet
