# function [D,W] = somwtodat(S,x)
#	D : resulting n x m matrix where 
#		n is the number of units and m the input dimension
#		(m = x * x)
#	W : visuallized image array
#	S : m x 1 vector containing SOM weights
#		row-major, 
#
#	* designed to plot Risto's fmnd fmsom weight files
#	* reshape() follows column-major, so it needs to be transposed
#
# $Id: somwtodat.m,v 1.2 2003/11/06 07:55:33 yschoe Exp yschoe $
#
function [D,W] = somwtodat(S,x)

  num_units = rows(S)/(x*x);
  D = reshape(S,x*x,num_units)';

  n = sqrt(num_units);

  W = zeros(n*x,n*x);
  for i=0:(n-1)
	for j=0:(n-1)
		W((n-1-j)*x+1:(n-1-j)*x+x,i*x+1:i*x+x) = reshape(D(i*n+j+1,:),x,x)';
	endfor
  endfor

endfunction

