# function [C,R] = wgtcontour(ormap,wgtmat,th,z,x,y) 
#	using ormap and wgtmat,
#	draw contour around wgt using threshold th (0.0--1.0) (absolute value)
#	with zoom of z and mark center x and y
#
#	white contour
#	thicker contour
function [C,R] = wgtcontour(orm,wgtmat,th,z,x,y) 

	z = 1;
	X=wgtmat; 
	ormap=orm; 
	s=rows(orm)*z; 

	# get thresholded weight
	T = sign(thresh(X,th)); 

	# get difference matrices (the outline contour)
	[sr,sc] = size(T);

	C = zeros(sr,sc);

	for i=1:(sr-1)
		for j=1:(sc-1)
			if T(i,j:j+1)==[0,1]
				C(i,j)=1;
			endif

			if T(i,j:j+1)==[1,0]
				C(i,j+1)=1;
			endif
		endfor
	endfor

	T += C;

	for i=1:(sr-1)
		for j=1:(sc-1)
			if T(i:i+1,j)==[0;1]
				C(i,j)=1;
			endif

			if T(i:i+1,j)==[1;0]
				C(i+1,j)=1;
			endif

		endfor
	endfor
	
	# mark center
	C(y-1:y+1,x-1:x+1) = ones(3,3); 
	C(y,x) = 0;
	
	# show the results
	yimage(flipud(C)); 
	R = flipud(min((abs(ones(s,s)-ormap(1:s,1:s).+0.01)),abs(ones(s,s)-C)));

	yimage(R,"hsvmap2");

endfunction



